﻿package com.incomingfodder 
{
	import com.baseoneonline.flash.astar.AStar;
	import com.baseoneonline.flash.geom.IntPoint;
	
	/**
	* ...
	* @author <christoffer@enedahl.com>
	*/
	public class AStarMonster extends Monster
	{
		
		public function AStarMonster(tx:int = 0, ty:int = 0) 
		{
			super(tx, ty);
			
		}
		
		private function updateAStar()
		{
			if (Goal != null)
			{
			
				aStar = new AStar( Game.GridMap, new IntPoint(Tx, Ty ), new IntPoint(Goal.Tx, Goal.Ty));				
				aStar.solve();
				
				//Debug show path
				//for (var i:int = 0; i < aStar.closed.length; i++)
				//{
					//var n:Node = new Node();
					//
					//n.x = (aStar.closed[i] as IntPoint).x * Game.TileSize;
					//n.y = (aStar.closed[i] as IntPoint).y * Game.TileSize;
					//Game.Canvas.addChild(n);
				//}
				
				
			}
		}
		
		/**
		 * Get the direction to walk next
		 * @return
		 */
		public override function getDirection():IntPoint
		{
			if (aStar == null)
			{
				updateAStar();
			}
			
			try{
				
				//Find my node, remove all before and my node
				for (var i:int = 0; i < aStar.closed.length; i++)
				{				
					if (aStar.closed[i].x == Tx && aStar.closed[i].y == Ty)
					{
						aStar.closed.splice(0, i+1); //remove all before
					}					
				}				
								
				var MoveX = aStar.closed[0].x - Tx;
				var MoveY = aStar.closed[0].y - Ty;				
				
				
				if (Math.abs(MoveX) < Math.abs( MoveY) ){
					MoveX = 0;
					if (MoveY < 0){
						MoveY = -1;
					}else if (MoveY > 0){
						MoveY = 1;
					}
				}else{
					MoveY = 0;
					if (MoveX < 0){
						MoveX = -1;
					}else if (MoveX > 0){
						MoveX = 1;
					}	
				}
				
				return new IntPoint( MoveX, MoveY);
				
			}catch (e:Error)
			{ 
				if(aStar.closed.length>0){
					trace("Astart GetDir " + e.message);
				}
			}
			
			return new IntPoint(); //No direction
		}
		
		/**
		 * rethink the path if hit on something thats not a goal
		 */
		public override function rethinkPath()
		{			
			trace("Rethinking path");
			updateAStar();
		}
		
	}
	
}