﻿package com.incomingfodder 
{
	import com.baseoneonline.flash.geom.IntPoint;
	import flash.geom.Point;
	
	/**
	* ...
	* @author <christoffer@enedahl.com>
	*/
	public class Cannon extends AStarMonster
	{
		public var Range:int;
		
		public function Cannon(tx:int = 0, ty:int = 0) 
		{
			super(tx, ty);
		}
		
		/**
		 * Upgrade monster
		 * @param	level
		 */
		public override function setLevel(level:int)
		{
			reloadTime = 5000;
			
			switch(level)
			{
				case 1: 
					Speed = 1;
					Power = 0.1;
					Health = 5;
					Range = 2;
					break;
				case 2: 
					Speed = 0.7;
					Power = 0.7;
					Health = 5;
					Range = 2;				
					break;					
				
				case 3: 
					Speed = 1;
					Power = 1;	
					Health = 8;
					Range = 3;			
					break;
					
				
				case 4: 
					Speed = 1.2;
					Power = 2;	
					Health = 13;
					Range = 3;			
					break;					
				
				case 5: 
					Speed = 1.4;
					Power = 2;	
					Health = 18;
					Range = 3;			
					break;
					
					
				case 6: 
					Speed = 1.5;
					Power = 2.2;	
					Health = 20;
					Range = 4;			
					break;					
					
				case 7: 
					Speed = 1.7;
					Power = 2.4;
					Health = 22;
					Range = 4;				
					break;
			}
			
		}
		
		/**
		 * Get the direction to walk next
		 * @return
		 */
		public override function getDirection():IntPoint
		{
			var dir:IntPoint = super.getDirection();
			
			if (dir.x == 1) gotoAndStop(1);
			if (dir.x == -1) gotoAndStop(2);
			if (dir.y == -1) gotoAndStop(3);
			if (dir.y == 1) gotoAndStop(4);
			
			var now:Number = new Date().time;
			
			for ( var r:int = 1; r <= Range; r++)
			{
				if ( !Game.isTileFree( Tx + (dir.x * r),  Ty + (dir.y * r) ) )
				{
					if( (lastAttack + reloadTime) < now){
						lastAttack = now;
						
						var angle:Number = Math.atan2( dir.y, dir.x);			
						
						var c:CannonBall = new CannonBall( 5, Power, angle, Tx, Ty, Range * Game.TileSize, new Point(dir.x, dir.y));
						Game.Canvas.addChild( c );
						
					}
				}
			}
			
			return dir;
		}
		
		
		public override function dispose()
		{			
			Document.mp.stop();
			super.dispose();
		}
		
	}
	
}