﻿package com.incomingfodder 
{
	import com.baseoneonline.flash.astar.AStar;
	import com.baseoneonline.flash.geom.IntPoint;
	import flash.display.MovieClip;
	import flash.events.Event;
	
	/**
	* Base monster, very stupid
	* @author <christoffer@enedahl.com>
	*/
	public class Monster extends BaseObject
	{
		
		public var aStar:AStar;
		
		public var Power:int = 1;
		public var Speed:Number = 0.5;
		
		/**
		 * MS how long
		 */
		public var reloadTime:Number = 500;
		/**
		 * When was last attack
		 * */
		public var lastAttack:Number = 0;
				
		public var Goal:BaseObject;
		
		public function Monster( tx:int = -1 , ty:int = -1) 
		{
			Health = 1;
			
			if (tx>=0 && ty>=0)
			{
				this.x = tx * Game.TileSize;
				this.y = ty * Game.TileSize;
			}else{
			
				this.x = 0;
				this.y = 0;
			}
			
			Tx = Math.floor( this.x / Game.TileSize);
			Ty = Math.floor( this.y / Game.TileSize);
			
			this.addEventListener(Event.ENTER_FRAME, onEnterFrame, false, 0, true);
			
			//Game.Canvas.addEventListener("pauseGame", onPause, false, 0 , true);
		}
		
		/**
		 * Upgrade monster
		 * @param	level
		 */
		public function setLevel(level:int)
		{
			
			switch(level)
			{
				case 1: 
					Speed = 1;
					Power = 0.5;	
					Health = 1;	
					break;
				case 2: 
					Speed = 0.7;
					Power = 0.7;		
					Health = 1;				
					break;
					
				
				case 3: 
					Speed = 1;
					Power = 1;		
					Health = 2;				
					break;
					
				
				case 4: 
					Speed = 1.2;
					Power = 2;		
					Health = 2;				
					break;					
				
				case 5: 
					Speed = 1.4;
					Power = 2;		
					Health = 3;				
					break;
					
					
				case 6: 
					Speed = 1.5;
					Power = 2.2;	
					Health = 3;					
					break;					
					
				case 7: 
					Speed = 1.7;
					Power = 2.4;	
					Health = 4;					
					break;
			}
			
		}
		
		
		public function onPause(e:Event)
		{
			trace("Monster.onPause ");
		}
		
		public function hit(arrow:Arrow)
		{
			Health -= arrow.Power;
			if (Health <= 0)
			{
				var ca:CoinAnimation = new CoinAnimation();
				ca.x = x;
				ca.y = y;
				ca.play();				
				Game.Canvas.addChild( ca );
				
				Game.addGold( 1 );
				dispose();
			}
		}
		
		public override function dispose()
		{
			Game.removeMonster(this);
			this.removeEventListener(Event.ENTER_FRAME, onEnterFrame, false);
			
		}
		
		public function seekGoal()
		{
			var closestDist = Number.MAX_VALUE;
			
			for each( var goal:BaseObject in Game.MonsterGoals )
			{
				var distX = goal.x - x;
				var distY = goal.y - y;
				
				var dist2 = distX * distX + distY * distY;
				
				if ( dist2 < closestDist )
				{
					closestDist = dist2;					
					Goal = goal;
				}
			}
			
			
		}
		
		/**
		 * Get the direction to walk next
		 * @return
		 */
		public function getDirection():IntPoint
		{
			var MoveX = Goal.Tx - Tx;
			var MoveY = Goal.Ty - Ty;
			
			if (Math.abs(MoveX) < Math.abs( MoveY) ){
				MoveX = 0;
				if (MoveY < 0){
					MoveY = -1;
				}else if (MoveY > 0){
					MoveY = 1;
				}
			}else{
				MoveY = 0;
				if (MoveX < 0){
					MoveX = -1;
				}else if (MoveX > 0){
					MoveX = 1;
				}	
			}
			
			return new IntPoint( MoveX, MoveY);
			
		}
		
		public function onEnterFrame(e:Event)
		{			
			if ( !Game.IsRunning ) return; //Not running;
			
			if ( Goal == null)
			{
				seekGoal();
			}else
			{
				if (Goal.Health < 0)
				{
					Goal = null;
					seekGoal();
				}
			}
			
			if (Goal == null) return; //No goal nothing to do... ummm, what to do?
			
			//Walk towards goal, if something in the way, hit it
			
			var now:Number = new Date().time;
			
			var newTx:int = Math.floor( x / Game.TileSize );
			var newTy:int = Math.floor( y / Game.TileSize );
			
			if (newTy != Ty || newTx != Tx)
			{
				Game.moveMonsterInGrid( newTx, newTy, this );
			}
			
			Tx = newTx;
			Ty = newTy;
			
			if ( Game.isTileFree( Tx, Ty ) || Tx < 0 || Ty < 0 )
			{
				var Direction:IntPoint = getDirection();
				
				if ( Game.isTileFree( Tx + Direction.x, Ty + Direction.y ))
				{					
					x += Direction.x * Speed;
					y += Direction.y * Speed;
				}else
				{
					Game.hit( Tx+ Direction.x, Ty+ Direction.y, this );
				}
				
			}else
			{ //My tile is occupied WTF?! hit it!
				
				if( (lastAttack + reloadTime) < now){
					lastAttack = now;
					Game.hit( Tx, Ty, this );
					//trace("Hit " + Tx + "x" + Ty +" "+ now);
					
					rethinkPath();
				}
			}
		}
		
		/**
		 * Override this if you want to rethink the path if hit on something thats not a goal
		 */
		public function rethinkPath()
		{
			
		}
		
	}
	
}